use crate::{lrr::LRR, rate::Rate, snr::SNR};

pub const DEFAULT_SAMPLE_RATE: Rate = Rate::Hz0k375;
pub const DEFAULT_CENTERFREQ: f64 = 1_500.;
pub const DEFAULT_BANDWIDTH: f64 = 250.;
pub const DEFAULT_TIMERES: usize = 7;
pub const DEFAULT_SPECTRES: usize = 7;
pub const DEFAULT_DRIFTRES: usize = 5;
pub const DEFAULT_SNR_THRESHOLD: SNR = SNR::new(0.28);
pub const DEFAULT_LRR_THRESHOLD: LRR = LRR::new(2.0);

pub const SYMBOL_COUNT: usize = 162;
pub const SYMBOL_DISTANCE: f64 = 375. / 256.;
pub const SYMBOL_DURATION: f64 = 1. / SYMBOL_DISTANCE;
pub const SYMBOL_DRIFT: f64 = SYMBOL_DISTANCE * SYMBOL_DISTANCE / SYMBOL_COUNT as f64;

pub const OUTLIER_XSIGMA: f64 = 2.0;

pub const BLOCK_EXTRA: usize = 4;
pub const BLOCK_COUNT: usize = SYMBOL_COUNT + BLOCK_EXTRA;

pub const POLY1: u32 = 0xF2D05351;
pub const POLY2: u32 = 0xE4613C47;

pub const POLY1_REV: u32 = POLY1.reverse_bits();
pub const POLY2_REV: u32 = POLY2.reverse_bits();

pub const SYNC: [u8; 162] = [
    1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0,
    0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 0,
    0, 0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 0, 1, 0,
    0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1,
    0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0,
    0, 0,
];

pub const SYNC64: [f64; 162] = [
    1.0, 1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, 1.0, -1.0, -1.0, -1.0, 1.0, 1.0, 1.0, -1.0, -1.0,
    -1.0, 1.0, -1.0, -1.0, 1.0, -1.0, 1.0, 1.0, 1.0, 1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0,
    1.0, -1.0, -1.0, 1.0, -1.0, 1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, 1.0, -1.0, 1.0, 1.0, -1.0,
    -1.0, 1.0, 1.0, -1.0, 1.0, -1.0, -1.0, -1.0, 1.0, 1.0, -1.0, 1.0, -1.0, -1.0, -1.0, -1.0, 1.0,
    1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, -1.0, 1.0, -1.0, -1.0, 1.0, -1.0, 1.0,
    1.0, -1.0, -1.0, -1.0, 1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, -1.0, -1.0, 1.0, -1.0, -1.0, -1.0,
    -1.0, -1.0, 1.0, -1.0, -1.0, 1.0, -1.0, -1.0, 1.0, 1.0, 1.0, -1.0, 1.0, 1.0, -1.0, -1.0, 1.0,
    1.0, -1.0, 1.0, -1.0, -1.0, -1.0, 1.0, 1.0, 1.0, -1.0, -1.0, -1.0, -1.0, -1.0, 1.0, -1.0, 1.0,
    -1.0, -1.0, 1.0, 1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, 1.0, 1.0, -1.0, 1.0, -1.0, 1.0,
    1.0, -1.0, -1.0, -1.0, 1.0, 1.0, -1.0, -1.0, -1.0,
];

pub const ARC64: [f64; 162] = [
    0.012345679012345678,
    0.024691358024691357,
    0.037037037037037035,
    0.04938271604938271,
    0.06172839506172839,
    0.07407407407407407,
    0.08641975308641975,
    0.09876543209876543,
    0.1111111111111111,
    0.12345679012345678,
    0.13580246913580246,
    0.14814814814814814,
    0.16049382716049382,
    0.1728395061728395,
    0.18518518518518517,
    0.19753086419753085,
    0.20987654320987653,
    0.2222222222222222,
    0.2345679012345679,
    0.24691358024691357,
    0.25925925925925924,
    0.2716049382716049,
    0.2839506172839506,
    0.2962962962962963,
    0.30864197530864196,
    0.32098765432098764,
    0.3333333333333333,
    0.345679012345679,
    0.35802469135802467,
    0.37037037037037035,
    0.38271604938271603,
    0.3950617283950617,
    0.4074074074074074,
    0.41975308641975306,
    0.43209876543209874,
    0.4444444444444444,
    0.4567901234567901,
    0.4691358024691358,
    0.48148148148148145,
    0.49382716049382713,
    0.5061728395061729,
    0.5185185185185185,
    0.5308641975308642,
    0.5432098765432098,
    0.5555555555555556,
    0.5679012345679012,
    0.5802469135802469,
    0.5925925925925926,
    0.6049382716049383,
    0.6172839506172839,
    0.6296296296296297,
    0.6419753086419753,
    0.654320987654321,
    0.6666666666666666,
    0.6790123456790124,
    0.691358024691358,
    0.7037037037037037,
    0.7160493827160493,
    0.7283950617283951,
    0.7407407407407407,
    0.7530864197530864,
    0.7654320987654321,
    0.7777777777777778,
    0.7901234567901234,
    0.8024691358024691,
    0.8148148148148148,
    0.8271604938271605,
    0.8395061728395061,
    0.8518518518518519,
    0.8641975308641975,
    0.8765432098765432,
    0.8888888888888888,
    0.9012345679012346,
    0.9135802469135802,
    0.9259259259259259,
    0.9382716049382716,
    0.9506172839506173,
    0.9629629629629629,
    0.9753086419753086,
    0.9876543209876543,
    1.0,
    1.0,
    0.9876543209876543,
    0.9753086419753086,
    0.9629629629629629,
    0.9506172839506173,
    0.9382716049382716,
    0.9259259259259259,
    0.9135802469135802,
    0.9012345679012346,
    0.8888888888888888,
    0.8765432098765432,
    0.8641975308641975,
    0.8518518518518519,
    0.8395061728395061,
    0.8271604938271605,
    0.8148148148148148,
    0.8024691358024691,
    0.7901234567901234,
    0.7777777777777778,
    0.7654320987654321,
    0.7530864197530864,
    0.7407407407407407,
    0.7283950617283951,
    0.7160493827160493,
    0.7037037037037037,
    0.691358024691358,
    0.6790123456790124,
    0.6666666666666666,
    0.654320987654321,
    0.6419753086419753,
    0.6296296296296297,
    0.6172839506172839,
    0.6049382716049383,
    0.5925925925925926,
    0.5802469135802469,
    0.5679012345679012,
    0.5555555555555556,
    0.5432098765432098,
    0.5308641975308642,
    0.5185185185185185,
    0.5061728395061729,
    0.49382716049382713,
    0.48148148148148145,
    0.4691358024691358,
    0.4567901234567901,
    0.4444444444444444,
    0.43209876543209874,
    0.41975308641975306,
    0.4074074074074074,
    0.3950617283950617,
    0.38271604938271603,
    0.37037037037037035,
    0.35802469135802467,
    0.345679012345679,
    0.3333333333333333,
    0.32098765432098764,
    0.30864197530864196,
    0.2962962962962963,
    0.2839506172839506,
    0.2716049382716049,
    0.25925925925925924,
    0.24691358024691357,
    0.2345679012345679,
    0.2222222222222222,
    0.20987654320987653,
    0.19753086419753085,
    0.18518518518518517,
    0.1728395061728395,
    0.16049382716049382,
    0.14814814814814814,
    0.13580246913580246,
    0.12345679012345678,
    0.1111111111111111,
    0.09876543209876543,
    0.08641975308641975,
    0.07407407407407407,
    0.06172839506172839,
    0.04938271604938271,
    0.037037037037037035,
    0.024691358024691357,
    0.012345679012345678,
];
